unit ThreadUnit;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, StdCtrls;

type

  { TTestThread }

  TTestThread = class(TThread)
    private
      FisTerminated: boolean;
      FMemo: TMemo;
      FThreadData: String;
      procedure SetMemo(AValue: TMemo);
      procedure SetThreadData(AValue: String);
    public
      property ThreadData:String read FThreadData write SetThreadData;
      property isTerminated: boolean read FisTerminated;
      procedure ShowData;
      Constructor Create(aMemo:TMemo);
      Procedure Execute; Override;
  end;

implementation

{ TTestThread }

procedure TTestThread.SetThreadData(AValue: String);
begin
  if FThreadData=AValue then Exit;
  FThreadData:=AValue;
end;

procedure TTestThread.SetMemo(AValue: TMemo);
begin
  if FMemo=AValue then Exit;
  FMemo:=AValue;
end;

procedure TTestThread.ShowData;

begin
  FMemo.Lines.add(Format('Thread %d says: %s',[Self.ThreadID,FThreadData]));
end;

constructor TTestThread.Create(aMemo: TMemo);
begin
  inherited create(true);
  self.FreeOnTerminate := false;
  FMemo := aMemo;
end;

procedure TTestThread.Execute;

var
  SleepTime:LongInt;

begin
  FisTerminated := false;
  FThreadData := 'Thread started';
  Synchronize(@ShowData);
  while not terminated do
    begin
      SleepTime := Random(4900) + 100;
      FThreadData := Format('I am alive! Going to sleep for %d ms',[SleepTime]);
      Synchronize(@ShowData);
      Self.Sleep(SleepTime);
    end;
  FThreadData := 'Thread stopped';
  Synchronize(@ShowData);
  FisTerminated := true;
end;

end.

